<!DOCTYPE html>

<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Task 68</title>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome Icons -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
</head>

<body class="hold-transition sidebar-mini">

    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">Home</a>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->
        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="#" class="brand-link">
                <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
                    style="opacity: .8">
                <span class="brand-text font-weight-light">Devcamp 120</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <!-- Sidebar user panel (optional) -->
                <div class="user-panel mt-3 pb-3 mb-3 d-flex">
                    <div class="image">
                        <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
                    </div>
                    <div class="info">
                        <a href="#" class="d-block">Hồ Bá TRường</a>
                    </div>
                </div>


                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
                        <li class="nav-item menu-open">
                            <a href="#" class="nav-link">
                                <i class="nav-icon fas fa-tachometer-alt"></i>
                                <p>
                                    Starter Pages
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="Voucher.html" class="nav-link ">
                                <i class="far fa-circle nav-icon"></i>
                                <p>
                                    Voucher list
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="CMenu.html" class="nav-link ">
                                <i class="far fa-circle nav-icon"></i>
                                <p>
                                    CMenu list
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="CDrink.html" class="nav-link ">
                                <i class="far fa-circle nav-icon"></i>
                                <p>
                                    CDrink list
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="Country.html" class="nav-link active">
                                <i class="far fa-circle nav-icon"></i>
                                <p>
                                    Country list
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="User.html" class="nav-link ">
                                <i class="far fa-circle nav-icon"></i>
                                <p>
                                    User list
                                </p>
                            </a>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <div class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                            <h2>DANH SÁCH COUNTRY</h2>
                        </div><!-- /.col -->
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">Country list</li>
                            </ol>
                        </div><!-- /.col -->
                    </div><!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content-header -->

            <!-- Main content -->
            <div class="content">
                <div class="container-fluid">
                    <div class="row">
                        <button class="btn btn-primary" id="btn-create"><i class="fa-solid fa-plus"></i> &nbsp; Create
                            Country</button>
                        <div class="col-12">
                            <table class="table table-bordered table-striped table-hover" id="country-table">
                                <thead>
                                    <tr>
                                        <th>ID</th>
                                        <th>Country Code</th>
                                        <th>Country Name</th>
                                        <th>Action</th>
                                        <th>Danh sách Region</th>
                                    </tr>
                            </table>
                            <!-- Vùng Modal -->
                            <!-- Create Order modal -->
                            <div>
                                <div id="create-country-modal" class="modal fade" tabindex="-1">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="h5-modal-title">Create Country
                                                </h5>
                                                <button class="close" data-dismiss="modal">&times;</button>
                                            </div>
                                            <div class="modal-body">
                                                <form>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Mã Country</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-create-countryCode"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Tên Country</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-create-countryName"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                </form>
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-secondary" id="btn-create-cancel"
                                                    data-dismiss="modal">Cancel</button>
                                                <button class="btn btn-primary" id="btn-create-country">Create
                                                    country</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <!-- Update Order modal -->
                            <div>
                                <div id="update-country-modal" class="modal fade" tabindex="-1">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="h5-modal-title">Update Trạng Thái country
                                                </h5>
                                                <button class="close" data-dismiss="modal">&times;</button>
                                            </div>
                                            <div class="modal-body">
                                                <form>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Mã Country</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-update-countryCode"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Tên Country</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-update-countryName"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                </form>
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-secondary" id="btn-update-cancel"
                                                    data-dismiss="modal">Cancel</button>
                                                <button class="btn btn-primary" id="btn-update-country">Update Trạng
                                                    Thái</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <!-- Delete confirm modal -->
                            <div>
                                <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="h5-modal-title">Country Delete Confirmation
                                                </h5>
                                                <button class="close" data-dismiss="modal">&times;</button>
                                            </div>
                                            <div class="modal-body">
                                                <label>Bạn có chắc chắn muốn xóa country này không?</label>
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-danger"
                                                    id="btn-confirm-delete-country">Confirm</button>
                                                <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <!-- Order Detail modal -->
                            <div>

                            </div>
                        </div>
                    </div>
                    <!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content -->
        </div>
        <!-- Main Footer -->
        <footer class="main-footer">
            <!-- To the right -->
            <div class="float-right d-none d-sm-inline">
                DANH SÁCH ĐƠN HÀNG
            </div>
            <!-- Default to the left -->
            <strong>Copyright &copy; 2023 Devcamp 120.</strong> All rights
            reserved.
        </footer>
    </div>
    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <script>
        "use strict";
        $(document).ready(function () {
            /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
            const gBASE_URL = "http://localhost:8080/country/";

            const gCOLUMN_ID = 0;
            const gCOLUMN_COUNTRY_CODE = 1;
            const gCOLUMN_COUNTRY_NAME = 2;
            const gCOLUMN_ACTION = 3;
            const gCOLUMN_DS_REGION = 4;

            const gCOLUMN = ["id", "countryCode", "countryName","action","dsregion"];

            var gCountry_code = {
                id: "",
            }
            // định nghĩa table  - chưa có data
            var gcountryTable = $("#country-table").DataTable({
                // Khai báo các cột của datatable
                "columns": [
                    { "data": gCOLUMN[gCOLUMN_ID] },
                    { "data": gCOLUMN[gCOLUMN_COUNTRY_CODE] },
                    { "data": gCOLUMN[gCOLUMN_COUNTRY_NAME] },
                    { "data": gCOLUMN[gCOLUMN_ACTION] },
                    { "data": gCOLUMN[gCOLUMN_DS_REGION] }
                ],
                // Ghi đè nội dung của cột action, chuyển thành button chi tiết
                "columnDefs": [
                    {
                        "targets": gCOLUMN_ACTION,
                        "defaultContent": '<i class="fas fa-pen text-info edit-country"></i> &nbsp &nbsp &nbsp <i class="fas fa-trash text-danger delete-country"></i>'
                    },
                    {
                        "targets": gCOLUMN_DS_REGION,
                        "defaultContent": '<button class="btn btn-primary region-country">Danh sách Region</button>'
                    }
                ]
            });

            /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
            onPageLoading();
            $("#btn-create").on("click", function () {
                $("#create-country-modal").modal("show");
            });
            $("#btn-create-country").on("click", function () {
                onCreatecountry();
            });
            $("#country-table").on("click", ".edit-country", function () {
                onButtonChiTietClick(this); // this là button được ấn
            });
            // khi ấn nút sự kiện update trên modal
            $("#btn-update-country").on("click", function () {
                onBtnUpdateClick();
            });
            // khi ấn sự kiện delete
            $("#country-table").on("click", ".delete-country", function () {
                onBtnDeleteConfirmOrderClick(this);
            });
            // gán sự kiện cho nút Delete  (trên modal)
            $("#btn-confirm-delete-country").on("click", function () {
                onBtnDeletecountryClick();
            });
            $("#country-table").on("click", ".region-country", function () {
                onBtnToRegionClick(this);
            });
            /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
            // Hàm sự kiện thêm country
            function onCreatecountry() {
                // khai báo dữ liệu
                var vcountryObj = {
                    countryCode: "",
                    countryName: "",
                }
                // thu thập thông tin 
                getCreateData(vcountryObj);
                // validate
                if (kiemtraCreateData(vcountryObj)) {
                    // Tạo mới order
                    createCountry(vcountryObj);
                }
            }
            // hàm thu thập thông tin để create order
            function getCreateData(paramObj) {
                paramObj.countryCode = $("#input-create-countryCode").val();
                paramObj.countryName = $("#input-create-countryName").val();
            }
            function kiemtraCreateData(paramObj) {
                if (paramObj.countryCode == "" ) {
                    alert("Bạn điền mã country không hợp lệ")
                    return false;
                }
                if (paramObj.countryName == "" ) {
                    alert("Bạn điền tên country không hợp lệ")
                    return false;
                }
                return true;
            }
            //Hàm tạo đơn mói
            function createCountry(paramObj) {
                $.ajax({
                    url: gBASE_URL + "create",
                    type: 'POST',
                    data: JSON.stringify(paramObj),
                    contentType: "application/json; charset=utf-8",
                    dataType: 'json',
                    success: function (paramObjcountry) {
                        //hiển thị dữ liệu lên web
                        console.log(paramObjcountry);
                        onPageLoading();
                        $("#create-country-modal").modal("hide");
                        alert("Bạn tạo thành công country");
                        $("#input-create-countryCode").val("");
                        $("#input-create-countryName").val("");
                    },
                    error: function (error) {
                        alert("Bạn tạo country thất bại!");
                        console.log(error.responseText)
                    }
                });
            }
            // infoFunction sẽ là function các nút cùng gọi
            function onButtonChiTietClick(paramChiTietButton) {
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramChiTietButton).parents('tr');
                //Lấy datatable row
                var vDatatableRow = gcountryTable.row(vRowSelected);
                //Lấy data của dòng 
                var vcountryData = vDatatableRow.data();
                gCountry_code.id = vcountryData.id;
                // lấy api để load vào modal
                getcountrybycountryID();
                $("#update-country-modal").modal("show");
            }
            function getcountrybycountryID() {
                $.ajax({
                    url: "http://localhost:8080/country/details/" + gCountry_code.id,
                    type: "GET",
                    dataType: 'json',
                    success: function (responseObject) {
                        //debugger;
                        loadDataToModal(responseObject);
                    },
                    error: function (error) {
                        console.assert(error.responseText);
                    }
                });
            }
            // hàm load data to modal update
            function loadDataToModal(paramResponseObject) {
                $("#input-update-countryCode").val(paramResponseObject.countryCode);
                $("#input-update-countryName").val(paramResponseObject.countryName);
            }
            function onPageLoading() {
                //Khai báo dữ liệu
                //validate
                // lấy data từ server
                getAllcountrybyapi();
                // Xử lý front-end
            }

            /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
            function getAllcountrybyapi() {
                $.ajax({
                    url: gBASE_URL + "all",
                    type: "GET",
                    dataType: 'json',
                    success: function (responseObject) {
                        //debugger;
                        loadDataToTable(responseObject);
                    },
                    error: function (error) {
                        console.assert(error.responseText);
                    }
                });
            }
            // load data to table
            function loadDataToTable(paramResponseObject) {
                //Xóa toàn bộ dữ liệu đang có của bảng
                gcountryTable.clear();
                //Cập nhật data cho bảng 
                gcountryTable.rows.add(paramResponseObject);
                //Cập nhật lại giao diện hiển thị bảng
                gcountryTable.draw();
            }
            // khi bấm nút Update trên modal
            function onBtnUpdateClick() {
                console.log(gCountry_code.id);
                //khai báo dữ liệu
                var vObjectRequest = {
                    countryCode: "",
                    countryName: ""
                }
                // gán dữ liệu
                vObjectRequest.countryCode = $("#input-update-countryCode").val();
                vObjectRequest.countryName = $("#input-update-countryName").val();
                //validate
                var validate = kiemtraCreateData(vObjectRequest);
                if (validate) {
                    //cập nhật trạng thái
                    updateCountry(vObjectRequest);
                }
            }
            //update country
            function updateCountry(paramObj) {
                $.ajax({
                    url: gBASE_URL + "update/" + gCountry_code.id,
                    type: "PUT",
                    data: JSON.stringify(paramObj),
                    contentType: "application/json; charset=utf-8",
                    dataType: 'json',
                    success: function (responseObject) {
                        //debugger;
                        handleUpdatetSuccess(responseObject.id);
                    },
                    error: function (error) {
                        console.assert(error.responseText);
                    }
                });
            }
            // hàm xử lý sự kiện delete order modal click
            function onBtnDeletecountryClick() {
                //khai báo dữ liệu
                //validate
                //gọi api
                $.ajax({
                    url: gBASE_URL + "delete/" + gCountry_code.id,
                    type: "DELETE",
                    contentType: "application/json; charset=utf-8",
                    success: function (paramRes) {
                        // B4: xử lý front-end
                        handleDeletecountrySuccess();
                    },
                    error: function (paramErr) {
                        console.log(paramErr.status);
                    }
                });
                //hiển thị thông tin
            }
            // hàm xử lý hiển thị front-end khi update Trạng thái thành công
            function handleUpdatetSuccess(paramObj) {
                onPageLoading();
                alert("Update country Id = " + paramObj + " thành công!");
                $("#update-country-modal").modal("hide");
            }
            // hàm xử lý hiển thị front-end khi sửa country thành công
            function handleDeletecountrySuccess() {
                onPageLoading();
                alert("Xóa country thành công!");
                $("#delete-confirm-modal").modal("hide");
            }
            function onBtnDeleteConfirmOrderClick(paramChiTietButton) {
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramChiTietButton).parents('tr');
                //Lấy datatable row
                var vDatatableRow = gcountryTable.row(vRowSelected);
                //Lấy data của dòng 
                var vcountryData = vDatatableRow.data();
                gCountry_code.id = vcountryData.id;
                // lấy api để load vào modal
                $("#delete-confirm-modal").modal("show");
            }
            function onBtnToRegionClick(paramChiTietButton) {
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramChiTietButton).parents('tr');
                //Lấy datatable row
                var vDatatableRow = gcountryTable.row(vRowSelected);
                //Lấy data của dòng 
                var vOrderData = vDatatableRow.data();
                gCountry_code.id = vOrderData.id;
                // location trang mới
                var vUrlSiteToOpen = "Region.html" +
                    "?id=" + gCountry_code.id;
                window.location.href = vUrlSiteToOpen;

            }
        });
    </script>
</body>

</html>